import numpy as np
from karabo.bound import NDARRAY_ELEMENT
from .base_addon import BaseCorrectionAddon


def maybe_get(a):
    # TODO: proper check for cupy
    if hasattr(a, "get"):
        return a.get()
    return a


class IntegratedIntensityAddon(BaseCorrectionAddon):
    _node_name = "integratedIntensity"

    @staticmethod
    def extend_output_schema(schema):
        # note: sort of assumes XTDF hash structure
        (
            NDARRAY_ELEMENT(schema)
            .key("image.integratedIntensity")
            .dtype("DOUBLE")
            .commit()
        )

    def post_correction(self, processed_data, cell_table, pulse_table, output_hash):
        # Numpy should handle CuPy dispatch for us
        output_hash["image.integratedIntensity"] = maybe_get(
            np.nansum(processed_data, axis=(1, 2))
        )
